//SETA43 15/11/2015
//Juan Galaz
// xsetaseta@gmail.com
// gps->SD
//Arduino Version 1.0.5
//Debian 7

#include <SoftwareSerial.h>

#include <SD.h>
File dataFile;


#include <EEPROM.h>
unsigned int nfichero;
char namefichero[15];
char fileplay[20] ;

#define DEBUG  0
#define MAXBUFFER  200
#define STOMAS  10

//STOMAS --segundos entre tomas


char bufferOut[MAXBUFFER];

char buffer[MAXBUFFER];
char inChar;
boolean stringComplete = true;
int contador;

char buffer2[12];
char coor1[12];
char coor2[12];
char coorLo;
char coorLa;
char metros[8];
char satelites[3];
char hora[12];
char fecha[12];
char velocidad[12];
long velocidadk;

SoftwareSerial mySerial(8,9); // RX, TX

unsigned int contadorTomas;
unsigned int contadorTiempo;
byte modo;
//0=grabar off
//1=grabar on

char SDerror;
char ledState = LOW; 

void setup()  
{
   pinMode(2, OUTPUT); //luces
   pinMode(3, OUTPUT);
   
   pinMode(5, OUTPUT);
   
   pinMode(4, INPUT);  //Botones 
  
   Serial.begin(9600);
   while (!Serial) {   ;} 
   Serial.println("gps->SD");
   mySerial.begin(9600);
   
   pinMode(10, OUTPUT);    // si utilizamos la salida 10 como CS de la tarjeta SD
   if(!SD.begin(10)) 
      {  Serial.println("Tarjeta erronea o no insertada");  SDerror=1;  }
   else
      {  Serial.println("Tarjeta OK"); SDerror=0;  }
   
   contadorTiempo=0;
   contadorTomas=0;
   modo=0; 
   if(SDerror==0)
       {digitalWrite(5, HIGH);}
   else
        {digitalWrite(5, LOW);}
}

void loop() 
{
 int z;
 char mibuffer[20];
 
 if(SDerror==0)
  {
  if(modo==0)
   {
       if(!digitalRead(4))  //Boton grabar datos GPS
                { 
                  newName();
                  strcpy(fileplay,namefichero); 
                  dataFile = SD.open(fileplay,FILE_WRITE);
                  Serial.print("Abriendo archivo en SD "); Serial.println(fileplay);
                  modo=1;
                  contadorTiempo=0;
                  digitalWrite(2, HIGH);
                  delay(300);  
                  while(!digitalRead(4));                
                }
   }
   else
   {
      if(!digitalRead(4))  //Boton para grabacion
                { 
                  dataFile.close();
                  Serial.println("Cerrado archivo SD");
                  modo=0;  
                  digitalWrite(2, LOW); 
                  delay(300); 
                  while(!digitalRead(4));                
                }      
   }
  }
  if (mySerial.available())
    {
      inChar = (char)mySerial.read(); 
      buffer[contador]=inChar; 
      if (inChar == '\n')
        {
          stringComplete = true;
          buffer[contador]=0;              
        } 
      if(contador<MAXBUFFER)contador++;          
    }
    if( stringComplete == true)
      {        
        stringComplete = false;
                
        if(!strncmp(buffer,"$GPGGA",6))
          {
            #if DEBUG
             Serial.println(buffer);
           #endif
           getCadenaBuffer(1); strcpy(hora,buffer2); hora[6]=0;           
           getCadenaBuffer(2); strcpy(coor1,buffer2);
           getCadenaBuffer(3); coorLo=buffer2[0]; 
           getCadenaBuffer(4); strcpy(coor2,buffer2);           
           getCadenaBuffer(5); coorLa=buffer2[0];                  
           getCadenaBuffer(9); strcpy(metros,buffer2);                                  
           getCadenaBuffer(7); strcpy(satelites,buffer2);
            sprintf(bufferOut,"%s,%c,%s,%c,%s,%s,%s,%d,",coor1,coorLo,coor2,coorLa, metros,hora,fecha,velocidadk);
            Serial.print(bufferOut);  Serial.println(contadorTiempo);
            if(modo==1 && SDerror==0 && contadorTomas==0) {digitalWrite(2, LOW); dataFile.print(bufferOut); dataFile.println(contadorTiempo); delay(100); digitalWrite(2, HIGH);}
            contadorTiempo++;
            contadorTomas++;
            if(contadorTomas>STOMAS) contadorTomas=0;
            
            if(2>strlen(coor1))
              {
               if (ledState == LOW)
                    ledState = HIGH;
                  else
                    ledState = LOW;
               digitalWrite(3, ledState);
              }
              else
              {
                digitalWrite(3, HIGH);
                ledState = HIGH;
              }         
           goto salto;                                   
          } 
        if(!strncmp(buffer,"$GPRMC",6))
          {
           #if DEBUG
             Serial.println(buffer);          
           #endif          
           getCadenaBuffer(7); strcpy(velocidad,buffer2);           
           getCadenaBuffer(9); strcpy(fecha,buffer2);          
           velocidadk=atol(velocidad); velocidadk*=1852 ;velocidadk/=1000;   
          }          
salto:          
        contador=0;
      }
  
}






void getCadenaBuffer(int n)
{
  int z,z1,contador2;
  z1=0;
  for(z=0;z<contador;z++)
    {
      if(buffer[z]==','){ z1++; if(z1==n) break;}
    }
  z++;
  contador2=0;
  for(;z<contador;z++)
    {
      buffer2[contador2]=buffer[z];
      if(buffer2[contador2]==','){ buffer2[contador2]=0; break;}
      if(contador2<12)contador2++;    
    }
}




//Funciones de toma de nombre mediante dato de la EPROM
void getName()
{ 
  nfichero=EEPROM.read(1);  nfichero =nfichero<<8;  nfichero+=EEPROM.read(0);  
  sprintf(namefichero,"%05d.txt",nfichero);
  Serial.println(namefichero);
}

void newName()
{
 byte value1;
 byte value0;
  nfichero=EEPROM.read(1);  nfichero =nfichero<<8;  nfichero+=EEPROM.read(0);  
  nfichero++;
  value0=nfichero & 0x00FF; value1=nfichero>>8;
  EEPROM.write(0, value0);   EEPROM.write(1, value1);
  sprintf(namefichero,"%05d.txt",nfichero);
  Serial.println(namefichero);
}

